<?php
/**
 *	ȈՃt@CǗ
 *
 *	@author	k.y,tsukikage
 *
 */

// ̃XNvgŊǗΏ̂̃fBNgwB
//define( 'PLUGIN_EZFM_ROOT_DIR', './ezfm' );// ΃pX
define( 'PLUGIN_EZFM_ROOT_DIR', '/home/users/([UƂ)/www/htdocs/wiki/plugin/ezfm' );// ΃pX
// R[hB
define( 'PLUGIN_EZFM_ENCODE', 'EUC-JP' );
// ۑt@C̕R[hB
define( 'PLUGIN_EZFM_ENCODE_SAVE', 'UTF-8' );
// o[WB
define( 'PLUGIN_EZFM_VERSION', '0.1' );
// PukiWiki[hB( 1  PukiWiki vOC[hB )
define( 'PLUGIN_EZFM_PUKIWIKI', 1 );
// ^CgB
define( 'PLUGIN_EZFM_TITLE', 'ezfm ver ' . PLUGIN_EZFM_VERSION );
// ̃XNvgB
define( 'PLUGIN_EZFM_SCRIPT', 'ezfm.inc.php' );
// ̃XNvg̃R}hB
define( 'PLUGIN_EZFM_COMMAND', 'ezfm' );

/**
 *	R}hŕ\B
 */
function plugin_ezfm_action() {

	global $vars, $_msg, $_body;

	$_msg = PLUGIN_EZFM_TITLE;
	$_body = plugin_ezfm_exec();

	return array( 'msg' => $_msg, 'body' => $_body );
}

/**
 *	CB
 */
function plugin_ezfm_exec() {

	global $vars;

if ( PLUGIN_EZFM_PUKIWIKI ) {
	$ezfm_cmd = isset($vars['ezfm_cmd']) ? $vars['ezfm_cmd'] : null;
	$path = isset($vars['path']) ? $vars['path'] : null;
	$htmlval = isset($vars['htmlval']) ? $vars['htmlval'] : null;
} else {
	$ezfm_cmd = isset($_POST['ezfm_cmd']) ? $_POST['ezfm_cmd'] : null;
	$path = isset($_POST['path']) ? $_POST['path'] : null;
	$htmlval = isset($_POST['htmlval']) ? $_POST['htmlval'] : null;
}

	// bZ[WB
	$msg = PLUGIN_EZFM_TITLE;

	// R}hȂꍇ̓Xg\B
	if ( !isset($ezfm_cmd) ) {
		return plugin_ezfm_showlist('new');
	}

	// pX́B
	if ( isset($path) ) {
		$ezfm_pathinfo = pathinfo( $path );
		$dir = $ezfm_pathinfo['dirname'];
		$file_name = $ezfm_pathinfo['basename'];
	}

	switch ( $ezfm_cmd ) {
		case 'new':
			$htmlval = plugin_ezfm_stripslashes( $htmlval );
			// ۑpɕR[hϊB
			$htmlval_for_save = plugin_ezfm_convert_code_for_save( $htmlval );
			if ( plugin_ezfm_write_file( $path, $htmlval_for_save ) ) {
				$msg = $path . ' created.';
			} else {
				$msg = 'file create failed.';
			}
			// \p̕ϊB
			$htmlval = htmlspecialchars( $htmlval, ENT_NOQUOTES );
			break;
		case 'update':
			$htmlval = plugin_ezfm_stripslashes( $htmlval );
			// ۑpɕR[hϊB
			$htmlval_for_save = plugin_ezfm_convert_code_for_save( $htmlval );
			if ( plugin_ezfm_write_file( $path, $htmlval_for_save ) ) {
				$msg = $path . ' updated.';
			} else {
				$msg = 'file update failed.';
			}
			// \p̕ϊB
			$htmlval = htmlspecialchars( $htmlval, ENT_NOQUOTES );
			break;
		case 'edit':
			$htmlval = plugin_ezfm_read_file( $path );
			// \pɕR[hϊB
			$htmlval = plugin_ezfm_convert_code( $htmlval, PLUGIN_EZFM_ENCODE );
			if ( isset($htmlval) ) {
				$msg = $path . ' opened.';
			} else {
				$msg = $path . ' open failed.';
			}
			// \p̕ϊB
			$htmlval = htmlspecialchars( $htmlval, ENT_NOQUOTES );
			break;
		case 'remove':
			$del_lst = plugin_ezfm_remove_files( $path );
			if ( isset($del_lst) && count($del_lst) > 0 ) {
				$msg = 'deleted following files. :';
				foreach ( $del_lst as $del_file )
					$msg .= '<br />' . $del_file;
			}
			$path = '';
			$dir = '';
			$file_name = '';
			break;
	}

	return plugin_ezfm_showlist($ezfm_cmd, $dir, $file_name, $htmlval, $msg);
}

/**
 *	t@Cɏ݁B
 */
function plugin_ezfm_write_file($file_path, $file_val) {
	if ( !file_exists($file_path) ) {
		if ( !touch( $file_path ) ) {
			return false;
		}
	}
	$fp = fopen( $file_path, "w" );
//	$fp = fopen( $file_path, "wb" );
	if ( $fp && isset( $fp ) ) {
		$res = fwrite( $fp, $file_val );
		fclose( $fp );
		return $res;
	}
	return false;
}

/**
 *	t@Cǂݍ݁B
 */
function plugin_ezfm_read_file($file_path) {
	if ( !file_exists($file_path) ) {
		return "";
	}
	$file_lines = file( $file_path );
	return join( "", $file_lines );
}

/**
 *	t@C폜B
 */
function plugin_ezfm_remove_file($file_path) {
	if ( !file_exists($file_path) ) {
		return false;
	}
	return unlink($file_path);
}

/**
 *	t@C폜B
 */
function plugin_ezfm_remove_files($file_paths) {
	$token = split( ',', $file_paths );
	foreach ( $token as $file_path ) {
		if ( plugin_ezfm_remove_file( $file_path ) ) 
			$res[] = $file_path;
	}
	return isset($res) ? $res : null;
}

/**
 *	fBNg쐬B
 */
function plugin_ezfm_mkdir($dir_name, $parent_path = PLUGIN_EZFM_ROOT_DIR) {
	if ( !isset($dir_name) ) return false;
	$full_path = $parent_path . '/' . $dir_name;
	return mkdir( $full_path );
}

/**
 *	fBNg폜B
 */
function plugin_ezfm_rmdir($dir_path) {
	if ( !isset($dir_path) ) return false;
	$indir = dir( $dir_path );
	if ( isset($indir) && $indir != null ) {
		while ( $file = $indir->read() ) {
			$file_path = $dir_path . '/' . $file;
			if ( is_file( $file_path ) ) {
				plugin_ezfm_remove_file( $file_path );
			} else if ( is_dir( $file_path ) ) {
				plugin_ezfm_rmdir( $file_path );
			}
		}
		$indir->close();
	}
	return true;
}

/*
 *	R[hϊB
 */
function plugin_ezfm_convert_code($str, $enc) {
	mb_detect_order( "UTF-8,SJIS,EUC-JP,JIS,ASCII" );
	return mb_convert_encoding( $str, $enc, mb_detect_encoding($str) );
}
/*
 *	R[hϊB(t@C)
 */
function plugin_ezfm_convert_code_for_save($str) {
	return mb_convert_encoding( $str, PLUGIN_EZFM_ENCODE_SAVE, PLUGIN_EZFM_ENCODE );
}
/*
 *	R[hϊB(t@C\)
 */
function plugin_ezfm_convert_code_for_read($str) {
	return mb_convert_encoding( $str, PLUGIN_EZFM_ENCODE, PLUGIN_EZFM_ENCODE_SAVE );
}

/**
 *	obNXbVB
 */
function plugin_ezfm_stripslashes($str) {
	if ( get_magic_quotes_gpc() ) {
		return stripslashes( $str );
	}
	return $str;
}

/*
 *	t@C擾
 */
function plugin_ezfm_getfiles(&$dir_lst, &$file_lst, $dir_path = PLUGIN_EZFM_ROOT_DIR) {

	$dir = dir($dir_path);
	if ( !$dir || !isset($dir) ) {
		return $file_lst;
	}
	while ( $file = $dir->read() ) {
		if ( $file == '.' || $file == '..' ) continue;
		$file_path = $dir_path . '/' . $file;
		if ( is_dir( $file_path ) ) {
			$dir_lst[] = $file_path;
			plugin_ezfm_getfiles( $dir_lst, $file_lst, $file_path );
		} else if ( is_file( $file_path ) ) {
			$file_lst[] = $file_path;
		}
	}
	$dir->close();

}

/*
 *	ꗗ\
 */
function plugin_ezfm_showlist($ezfm_cmd, $dir = '', $file_name = '', $htmlval = '', $msg = PLUGIN_EZFM_TITLE) {

	global $script, $vars;
	global $dir_lst, $file_lst;

	// eϐ̏B
if ( PLUGIN_EZFM_PUKIWIKI ) {
	$ezfm_script = $script . '?cmd=' . PLUGIN_EZFM_COMMAND;
} else {
	$ezfm_script = PLUGIN_EZFM_SCRIPT;
}

	// fBNg̃t@CSĎ擾B
	plugin_ezfm_getfiles( $dir_lst, $file_lst );

	// R}hB
	if ($ezfm_cmd == 'update' || $ezfm_cmd == 'edit') {
		$new_checked = '';
		$update_checked = 'checked';
	} else {
		$new_checked = 'checked';
		$update_checked = '';
	}

$_body = <<<EOH1
<style type="text/css">
div#ezfm {
	font-size: 10pt;
	width: 580px;
}
#ezfm table {
	width: 580px;
}
#ezfm table, #ezfm th, #ezfm td {
	border: solid 1px #ddd;
	border-collapse: collapse;
	border-spacing: 0px;
}
#ezfm tr, #ezfm th, #ezfm td, #ezfm input, #ezfm textarea {
	font-size: 10pt;
}
#ezfm th, #ezfm td {
	padding: 1px 5px;
}
#ezfm th {
	background-color: #ddd;
}
#ezfm .msg {
	font-size: 11pt;
}
</style>
<script type="text/javascript">
function doPost() {
	var modes = document.ezfm.mode;
	if (!modes || modes == undefined || modes.length == 0) {
		alert( 'mode not selected.' );
		return false;
	}
	for ( i = 0; i < modes.length; i++ ) {
		if ( modes[i].checked ) {
			document.ezfm.ezfm_cmd.value = modes[i].value;
			break;
		}
	}
	document.ezfm.path.value = document.ezfm.dir.value + '/' + document.ezfm.file_name.value;
	document.ezfm.submit();
	return false;
}
function doEdit(path) {
	document.ezfm.ezfm_cmd.value = 'edit';
	document.ezfm.path.value = path;
	document.ezfm.submit();
	return false;
}
function doRemove() {
	document.ezfm.ezfm_cmd.value = 'remove';
	var targets = document.ezfm.selection;
	if (!targets || targets == undefined || targets.length == 0) {
		alert( 'file not selected.' );
		return false;
	}
	var path = '';
	if ( targets.value && targets.value != undefined ) {
		path = targets.value;
	} else {
		for ( i = 0; i < targets.length; i++ ) {
			if ( targets[i].checked ) {
				if ( path == '' ) {
					path = targets[i].value;
				} else {
					path = path + ',' + targets[i].value;
				}
			}
		}
	}
	document.ezfm.path.value = path;
	document.ezfm.htmlval.value = '';
	document.ezfm.submit();
	return false;
}

</script>
<div id="ezfm">
<span class="msg">$msg</span>
<br />
<form name="ezfm" action="$ezfm_script" method="POST">
<p>Directory : <select name="dir">
EOH1;

	if ( !isset($dir) ) {
		$_body .= "<option value=\"".PLUGIN_EZFM_ROOT_DIR."\" selected>root</option>\n";
	} else {
		$_body .= "<option value=\"".PLUGIN_EZFM_ROOT_DIR."\">root</option>\n";
	}

	if ( isset($dir_lst) && count($dir_lst) > 0 ) {
		foreach ( $dir_lst as $dir_name ) {
			if ( $dir == $dir_name ) {
				$_body .= "<option value=\"" . $dir_name . "\" selected>" . $dir_name . "</option>\n";
			} else {
				$_body .= "<option value=\"" . $dir_name . "\">" . $dir_name . "</option>\n";
			}
		}
	}

$_body .= <<<EOH2
</select></p>

<p>File name : <input name="file_name" type="text" size="48" value="$file_name" /></p>
<p>HTML : <br />
<textarea name="htmlval" rows="8" cols="76">$htmlval</textarea></p>
&nbsp;
<input name="mode" type="radio" id="ezfm_new" value="new" $new_checked><label for="ezfm_new">New</label>&nbsp;
<input name="mode" type="radio" id="ezfm_update" value="update" $update_checked><label for="ezfm_update">Update</label>&nbsp;
<input type="button" value=" POST " onclick="doPost();" /><br />
<br />

<input name="ezfm_cmd" type="hidden" value="" />
<input name="path" type="hidden" value="" />
EOH2;

	if ( isset($file_lst) && count($file_lst) > 0 ) {

		$_body .= "<table>";
		$_body .= "<tr>";
		$_body .= "<th width=\"20\" nowrap>Select</th>";
		$_body .= "<th width=\"500\" nowrap>Path</th>";
		$_body .= "<th width=\"60\" nowrap>Command</th>";
		$_body .= "</tr>";

		foreach ( $file_lst as $file_path ) {
			$_body .= "<tr><td align=\"center\"><input name=\"selection\" type=\"checkbox\" value=\"" . $file_path . "\"></td><td align=\"left\">" . $file_path . "</td>";
			$_body .= "<td align=\"center\"><input name=\"edit\" type=\"button\" value=\"EDIT\" onclick=\"doEdit('" . $file_path . "');\"></td></tr>\n";
		}

		$_body .= "</table>";
		$_body .= "<br />";
		$_body .= "<input name=\"remove\" type=\"button\" value=\" REMOVE \" onclick=\"doRemove();\" /><br />";
	}

$_body .= <<<EOH3
</from>
</div>
EOH3;

	return $_body;
}

if ( !PLUGIN_EZFM_PUKIWIKI ) {
	echo "<html>\n<head>\n";
	echo "<meta http-equiv=\"Content-Type\" content=\"text/html;charset=" . PLUGIN_EZFM_ENCODE . "\" />\n";
	echo "<title>ezfm for PukiWiki</title>\n";
	echo "</head>\n<body>\n";
	echo plugin_ezfm_exec();
	echo "\n</body>\n</html>";
}
?>
